Index: issm/trunk/src/c/classes/objects/Elements/Penta.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Elements/Penta.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Elements/Penta.cpp	(revision 13975)
@@ -82,5 +82,5 @@
 	this->inputs=new Inputs();
 	this->results=new Results();
-	
+
 	/*initialize pointers:*/
 	this->nodes=NULL;
@@ -180,10 +180,9 @@
 
 	/*Intermediaries */
-	int    count,ig;
+	int    count;
 	IssmDouble basalfriction[NUMVERTICES]={0,0,0,0,0,0};
 	IssmDouble alpha2,vx,vy;
 	Friction*  friction=NULL;
 	GaussPenta* gauss=NULL;
-
 
 	/* Basal friction can only be found at the base of an ice sheet: */
@@ -199,5 +198,4 @@
 	Input* vz_input=inputs->GetInput(VzEnum);                         _assert_(vz_input);
 
-
 	/*Build friction element, needed later: */
 	friction=new Friction("3d",inputs,matpar,DiagnosticHorizAnalysisEnum);
@@ -206,5 +204,5 @@
 	gauss=new GaussPenta(0,1,2,2);
 	count=0;
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -216,5 +214,5 @@
 		count++;
 	}
-	
+
 	/*Create PentaVertex input, which will hold the basal friction:*/
 	this->inputs->AddInput(new PentaP1Input(BasalFrictionEnum,&basalfriction[0]));
@@ -228,21 +226,19 @@
 void  Penta::ComputeBasalStress(Vector<IssmDouble>* sigma_b){
 
-	int         i,j,ig;
+	int         i,j;
 	int         dofv[3]={0,1,2};
 	int         dofp[1]={3};
 	int         analysis_type,approximation;
-	int         doflist[NUMVERTICES];
-	IssmDouble      xyz_list[NUMVERTICES][3];
-	IssmDouble      xyz_list_tria[3][3];
-	IssmDouble      rho_ice,gravity,stokesreconditioning;
-	IssmDouble      pressure,viscosity,bed,Jdet2d;
-	IssmDouble      bed_normal[3];
-	IssmDouble      basalforce[3];
-	IssmDouble      epsilon[6]; /* epsilon=[exx,eyy,ezz,exy,exz,eyz];*/
-	IssmDouble      devstresstensor[6]; /* epsilon=[exx,eyy,ezz,exy,exz,eyz];*/
-	IssmDouble      stresstensor[6]={0.0};
-	IssmDouble      sigma_xx,sigma_yy,sigma_zz;
-	IssmDouble      sigma_xy,sigma_xz,sigma_yz;
-	IssmDouble      surface=0,value=0;
+	IssmDouble  xyz_list[NUMVERTICES][3];
+	IssmDouble  xyz_list_tria[3][3];
+	IssmDouble  rho_ice,gravity,stokesreconditioning;
+	IssmDouble  pressure,viscosity,Jdet2d;
+	IssmDouble  bed_normal[3];
+	IssmDouble  basalforce[3];
+	IssmDouble  epsilon[6]; /* epsilon=[exx,eyy,ezz,exy,exz,eyz];*/
+	IssmDouble  stresstensor[6]={0.0};
+	IssmDouble  sigma_xx,sigma_yy,sigma_zz;
+	IssmDouble  sigma_xy,sigma_xz,sigma_yz;
+	IssmDouble  surface=0,value=0;
 	GaussPenta* gauss;
 
@@ -257,5 +253,5 @@
 	/*retrieve some parameters: */
 	this->parameters->FindParam(&stokesreconditioning,DiagnosticStokesreconditioningEnum);
-	
+
 	if(!IsOnBed()){
 		//put zero
@@ -280,5 +276,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(0,1,2,2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -325,5 +321,4 @@
 void  Penta::ComputeStressTensor(){
 
-	int         iv;
 	IssmDouble      xyz_list[NUMVERTICES][3];
 	IssmDouble      pressure,viscosity;
@@ -364,5 +359,5 @@
 		sigma_yz[iv]=2*viscosity*epsilon[5];
 	}
-	
+
 	/*Add Stress tensor components into inputs*/
 	this->inputs->AddInput(new PentaP1Input(StressTensorxxEnum,&sigma_xx[0]));
@@ -381,5 +376,5 @@
 
 	int analysis_counter;
-	
+
 	/*go into parameters and get the analysis_counter: */
 	parametersin->FindParam(&analysis_counter,AnalysisCounterEnum);
@@ -421,5 +416,5 @@
 	_assert_(this->nodes && this->material && this->matpar && this->verticalneighbors && this->parameters && this->inputs);
 	/*}}}*/
-	
+
 	/*Skip if water element*/
 	if(IsOnWater()) return;
@@ -651,6 +646,4 @@
 void Penta::DeepEcho(void){
 
-	int i;
-	
 	_printLine_("Penta:");
 	_printLine_("   id: " << id);
@@ -672,6 +665,4 @@
 	_printLine_("neighboor sids: ");
 	_printLine_(" " << horizontalneighborsids[0] << " " << horizontalneighborsids[1] << " " << horizontalneighborsids[2]);
-
-	return;
 }
 /*}}}*/
@@ -794,5 +785,5 @@
 void  Penta::GetDofList(int** pdoflist,int approximation_enum,int setenum){
 
-	int  i,j,count=0;
+	int  i,count=0;
 	int  numberofdofs=0;
 	int* doflist=NULL;
@@ -815,9 +806,17 @@
 }
 /*}}}*/
-/*FUNCTION Penta::GetDofList1 {{{*/
-void  Penta::GetDofList1(int* doflist){
+/*FUNCTION Penta::GetVertexPidList {{{*/
+void  Penta::GetVertexPidList(int* doflist){
 
 	int i;
-	for(i=0;i<6;i++) doflist[i]=nodes[i]->GetDofList1();
+	for(i=0;i<6;i++) doflist[i]=nodes[i]->GetVertexPid();
+
+}
+/*}}}*/
+/*FUNCTION Penta::GetVertexSidList{{{*/
+void  Penta::GetVertexSidList(int* sidlist){
+
+	int i;
+	for(i=0;i<NUMVERTICES;i++) sidlist[i]=nodes[i]->GetVertexSid();
 
 }
@@ -892,10 +891,32 @@
 }
 /*}}}*/
+/*FUNCTION Penta::GetNodesSidList{{{*/
+void Penta::GetNodesSidList(int* sidlist){
+
+	_assert_(sidlist);
+	_assert_(nodes);
+
+	for(int i=0;i<NUMVERTICES;i++){
+		sidlist[i]=nodes[i]->Sid();
+	}
+}
+/*}}}*/
+/*FUNCTION Penta::GetNumberOfNodes{{{*/
+int Penta::GetNumberOfNodes(void){
+
+	if(this->nodes==NULL) return 0;
+
+	switch(this->element_type){
+		case P1Enum:
+			return 6;
+		case P1DGEnum:
+			return 6;
+		default:
+			_error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+	}
+}
+/*}}}*/
 /*FUNCTION Penta::GetInputListOnVertices(IssmDouble* pvalue,int enumtype) {{{*/
 void Penta::GetInputListOnVertices(IssmDouble* pvalue,int enumtype){
-
-	/*Intermediaries*/
-	IssmDouble     value[NUMVERTICES];
-	GaussPenta *gauss              = NULL;
 
 	/*Recover input*/
@@ -907,5 +928,5 @@
 
 	/* Start looping on the number of vertices: */
-	gauss=new GaussPenta();
+	GaussPenta *gauss=new GaussPenta();
 	for (int iv=0;iv<NUMVERTICES;iv++){
 		gauss->GaussVertex(iv);
@@ -920,8 +941,4 @@
 void Penta::GetInputListOnVertices(IssmDouble* pvalue,int enumtype,IssmDouble defaultvalue){
 
-	/*Intermediaries*/
-	IssmDouble     value[NUMVERTICES];
-	GaussPenta *gauss              = NULL;
-
 	/*Recover input*/
 	Input* input=inputs->GetInput(enumtype);
@@ -932,16 +949,14 @@
 	/* Start looping on the number of vertices: */
 	if (input){
-		gauss=new GaussPenta();
+		GaussPenta *gauss=new GaussPenta();
 		for (int iv=0;iv<NUMVERTICES;iv++){
 			gauss->GaussVertex(iv);
 			input->GetInputValue(&pvalue[iv],gauss);
 		}
+		delete gauss;
 	}
 	else{
 		for (int iv=0;iv<NUMVERTICES;iv++) pvalue[iv]=defaultvalue;
 	}
-
-	/*clean-up*/
-	delete gauss;
 }
 /*}}}*/
@@ -995,12 +1010,4 @@
 	 *    = 4 * mu * eps_eff ^2*/
 	*phi=4*pow(epsilon_eff,2.0)*viscosity;
-}
-/*}}}*/
-/*FUNCTION Penta::GetSidList{{{*/
-void  Penta::GetSidList(int* sidlist){
-
-	int i;
-	for(i=0;i<NUMVERTICES;i++) sidlist[i]=nodes[i]->GetSidList();
-
 }
 /*}}}*/
@@ -1135,5 +1142,5 @@
 void  Penta::GetVectorFromInputs(Vector<IssmDouble>* vector,int input_enum){
 
-	int doflist1[NUMVERTICES];
+	int vertexpidlist[NUMVERTICES];
 
 	/*Get out if this is not an element input*/
@@ -1141,5 +1148,5 @@
 
 	/*Prepare index list*/
-	this->GetDofList1(&doflist1[0]);
+	this->GetVertexPidList(&vertexpidlist[0]);
 
 	/*Get input (either in element or material)*/
@@ -1148,5 +1155,5 @@
 
 	/*We found the enum.  Use its values to fill into the vector, using the vertices ids: */
-	input->GetVectorFromInputs(vector,&doflist1[0]);
+	input->GetVectorFromInputs(vector,&vertexpidlist[0]);
 }
 /*}}}*/
@@ -1160,9 +1167,9 @@
 	}  
 	if(interp==P1Enum){
-		int doflist1[NUMVERTICES];
+		int vertexpidlist[NUMVERTICES];
 		int connectivity[NUMVERTICES];
-		this->GetSidList(&doflist1[0]);
+		this->GetVertexSidList(&vertexpidlist[0]);
 		this->GetConnectivityList(&connectivity[0]);
-		elementresult->GetVectorFromResults(vector,&doflist1[0],&connectivity[0],NUMVERTICES);
+		elementresult->GetVectorFromResults(vector,&vertexpidlist[0],&connectivity[0],NUMVERTICES);
 	}
 	else if(interp==P0Enum){
@@ -1191,5 +1198,5 @@
 /*FUNCTION Penta::Sid {{{*/
 int    Penta::Sid(){
-	
+
 	return sid;
 
@@ -1251,5 +1258,5 @@
 	/*Check that name is an element input*/
 	if (!IsInput(name)) return;
-	
+
 	if ((code==5) || (code==1)){ //boolean
 		this->inputs->AddInput(new BoolInput(name,reCast<bool,IssmDouble>(scalar)));
@@ -1269,5 +1276,5 @@
 
 	/*Intermediaries*/
-	int    i,j,t;
+	int    i,t;
 	int    penta_vertex_ids[6];
 	int    row;
@@ -1873,5 +1880,5 @@
 		penta=penta->GetUpperElement(); _assert_(penta->Id()!=this->id);
 	}
-	
+
 	/*Free ressources:*/
 	xDelete<int>(doflist);
@@ -1897,5 +1904,5 @@
 	/*Add input to the element: */
 	this->inputs->AddInput(new PentaP1Input(enum_type,values));
-	
+
 	/*Free ressources:*/
 	xDelete<int>(doflist);
@@ -1937,5 +1944,5 @@
 		penta=penta->GetUpperElement(); _assert_(penta->Id()!=this->id);
 	}
-	
+
 	/*Free ressources:*/
 	xDelete<int>(doflist);
@@ -1960,5 +1967,5 @@
 				/*Get values on the 6 vertices*/
 				for (int i=0;i<6;i++){
-					values[i]=vector[this->nodes[i]->GetVertexDof()];
+					values[i]=vector[this->nodes[i]->GetVertexPid()];
 				}
 
@@ -2162,4 +2169,5 @@
 	/*Recover info at the vertices: */
 	parameters->FindParam(&migration_style,GroundinglineMigrationEnum);
+	parameters->FindParam(&gl_melting_rate,GroundinglineMeltingRateEnum);
 	parameters->FindParam(&yts,ConstantsYtsEnum);
 	GetInputListOnVertices(&h[0],ThicknessEnum);
@@ -2170,5 +2178,5 @@
 	rho_ice=matpar->GetRhoIce();
 	density=rho_ice/rho_water;
-	
+
 	/*go through vertices, and update inputs, considering them to be PentaVertex type: */
 	for(i=0;i<NUMVERTICES;i++){
@@ -2211,5 +2219,5 @@
 		}
 	}
-	
+
    /*Add basal melting rate if element just ungrounded*/
 	if(!this->IsFloating() && elementonshelf==true){
@@ -2251,10 +2259,4 @@
 
 	return minlength;
-}
-/*}}}*/
-/*FUNCTION Penta::MyRank {{{*/
-int    Penta::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
 }
 /*}}}*/
@@ -2299,5 +2301,5 @@
 	/*recover pointer: */
 	count=*pcount;
-		
+
 	/*will be needed later: */
 	for(i=0;i<6;i++) vertices_ids[i]=nodes[i]->GetVertexId(); //vertices id start at column 3 of the patch.
@@ -2508,5 +2510,5 @@
 /*FUNCTION Penta::RequestedOutput{{{*/
 void Penta::RequestedOutput(int output_enum,int step,IssmDouble time){
-			
+
 	if(IsInput(output_enum)){
 		/*just transfer this input to results, and we are done: */
@@ -2607,4 +2609,55 @@
 }
 /*}}}*/
+/*FUNCTION Penta::SetwiseNodeConnectivity{{{*/
+void Penta::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int set1_enum,int set2_enum){
+
+	/*Output */
+	int d_nz = 0;
+	int o_nz = 0;
+
+	/*Loop over all nodes*/
+	for(int i=0;i<6;i++){
+
+		if(!flags[this->nodes[i]->Sid()]){
+
+			/*flag current node so that no other element processes it*/
+			flags[this->nodes[i]->Sid()]=true;
+
+			/*if node is clone, we have an off-diagonal non-zero, else it is a diagonal non-zero*/
+			switch(set2_enum){
+				case FsetEnum:
+					if(nodes[i]->indexing.fsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case GsetEnum:
+					if(nodes[i]->indexing.gsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case SsetEnum:
+					if(nodes[i]->indexing.ssize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				default: _error_("not supported");
+			}
+		}
+	}
+
+	/*Assign output pointers: */
+	*pd_nz=d_nz;
+	*po_nz=o_nz;
+}
+/*}}}*/
 /*FUNCTION Penta::SpawnTria {{{*/
 Tria*  Penta::SpawnTria(int g0, int g1, int g2){
@@ -2663,4 +2716,6 @@
 	IssmDouble b_neg[NUMVERTICES];				// Hs-SMB relation paremeter
 	IssmDouble Hc[NUMVERTICES];					// elevation of transition between accumulation regime and ablation regime
+	IssmDouble Href[NUMVERTICES];					// reference elevation from which deviations are used to calculate the SMB adjustment
+	IssmDouble Smbref[NUMVERTICES];				// reference SMB to which deviations are added
 	IssmDouble smb_pos_max[NUMVERTICES];		// maximum SMB value in the accumulation regime
 	IssmDouble smb_pos_min[NUMVERTICES];		// minimum SMB value in the accumulation regime
@@ -2673,4 +2728,6 @@
 	/*Recover SmbGradients*/
 	GetInputListOnVertices(&Hc[0],SurfaceforcingsHcEnum);
+	GetInputListOnVertices(&Href[0],SurfaceforcingsHrefEnum);
+	GetInputListOnVertices(&Smbref[0],SurfaceforcingsSmbrefEnum);
 	GetInputListOnVertices(&smb_pos_max[0],SurfaceforcingsSmbPosMaxEnum);
 	GetInputListOnVertices(&smb_pos_min[0],SurfaceforcingsSmbPosMinEnum);
@@ -2679,5 +2736,5 @@
 	GetInputListOnVertices(&a_neg[0],SurfaceforcingsANegEnum);
 	GetInputListOnVertices(&b_neg[0],SurfaceforcingsBNegEnum);
-	
+
    /*Recover surface elevatio at vertices: */
 	GetInputListOnVertices(&h[0],ThicknessEnum);
@@ -2687,17 +2744,18 @@
    rho_ice=matpar->GetRhoIce();
    rho_water=matpar->GetRhoFreshwater();
-			
+
    // loop over all vertices
-   for(i=0;i<NUMVERTICES;i++){
+ for(i=0;i<NUMVERTICES;i++){
      if(s[i]>Hc[i]){
-	    smb[i]=a_pos[i]+b_pos[i]*s[i];
-		 if(smb[i]>smb_pos_max[i]){smb[i]=smb_pos_max[i];}
-		 if(smb[i]<smb_pos_min[i]){smb[i]=smb_pos_min[i];}
+		  if(Href[i]>Hc[i]){smb[i]=Smbref[i]+b_pos[i]*(s[i]-Href[i]);}
+		  if(Href[i]<=Hc[i]){smb[i]=a_pos[i]+b_pos[i]*s[i];}
+		  if(smb[i]>smb_pos_max[i]){smb[i]=smb_pos_max[i];}
+		  if(smb[i]<smb_pos_min[i]){smb[i]=smb_pos_min[i];}
 	  }
 	  else{
-	    smb[i]=a_neg[i]+b_neg[i]*s[i];
+		  if(Href[i]>Hc[i]){smb[i]=a_neg[i]+b_neg[i]*s[i];}
+		  if(Href[i]<=Hc[i]){smb[i]=Smbref[i]+b_neg[i]*(s[i]-Href[i]);}
 	  }
 	  smb[i]=smb[i]/rho_ice;      // SMB in m/y ice		
-	  
 	}  //end of the loop over the vertices
 	  /*Update inputs*/
@@ -2792,5 +2850,5 @@
 	minz=xyz_list[0][2];
 	maxz=xyz_list[0][2];
-	
+
 	for(i=1;i<NUMVERTICES;i++){
 		if (xyz_list[i][0]<minx)minx=xyz_list[i][0];
@@ -2974,5 +3032,5 @@
 		if (reCast<bool,IssmDouble>(vertices_potentially_ungrounding[nodes[i]->Sid()])){
 			vec_nodes_on_iceshelf->SetValue(nodes[i]->Sid(),1,INS_VAL);
-		
+
 			/*If node was not on ice shelf, we flipped*/
 			if(nodes_on_iceshelf[nodes[i]->Sid()]==0){
@@ -2991,11 +3049,10 @@
 
 	/*Intermediaries*/
-	int    iv;
 	IssmDouble phi;
 	IssmDouble viscosity;
 	IssmDouble xyz_list[NUMVERTICES][3];
 	IssmDouble epsilon[6];
-	IssmDouble     viscousheating[NUMVERTICES]={0,0,0,0,0,0};
-	IssmDouble     thickness;
+	IssmDouble viscousheating[NUMVERTICES]={0,0,0,0,0,0};
+	IssmDouble thickness;
 	GaussPenta *gauss=NULL;
 
@@ -3014,5 +3071,5 @@
 	for (int iv=0;iv<NUMVERTICES;iv++){
 		gauss->GaussVertex(iv);
-		
+
 		thickness_input->GetInputValue(&thickness,gauss);
 
@@ -3020,5 +3077,4 @@
 		material->GetViscosity3dStokes(&viscosity,&epsilon[0]);
 		GetPhi(&phi, &epsilon[0], viscosity);
-		
 
 		viscousheating[iv]=phi*thickness;
@@ -3275,5 +3331,5 @@
 
 	if(IsOnWater() || !IsOnSurface()) return 0.;
-	
+
 	GetVerticesCoordinates(&xyz_list[0][0], nodes, NUMVERTICES);
 
@@ -3287,8 +3343,8 @@
 	smb_input->GetInputAverage(&smb);
 	Total_Smb=rho_ice*base*smb;// smb on element in kg s-1
-	
+
 	/*Process units: */
 	Total_Smb=UnitConversion(Total_Smb,IuToExtEnum,TotalSmbEnum);// smb on element in GigaTon yr-1
-	
+
 	/*Return: */
 	return Total_Smb;
@@ -3300,10 +3356,10 @@
 /*FUNCTION Penta::CreateKMatrixEnthalpy {{{*/
 ElementMatrix* Penta::CreateKMatrixEnthalpy(void){
-	
+
 	/*compute all stiffness matrices for this element*/
 	ElementMatrix* Ke1=CreateKMatrixEnthalpyVolume();
 	ElementMatrix* Ke2=CreateKMatrixEnthalpyShelf();
 	ElementMatrix* Ke =new ElementMatrix(Ke1,Ke2);
-	
+
 	/*clean-up and return*/
 	delete Ke1;
@@ -3320,23 +3376,23 @@
 	/*Intermediaries */
 	int        stabilization;
-	int        i,j,ig,found=0;
-	IssmDouble     Jdet,u,v,w,um,vm,wm;
-	IssmDouble     h,hx,hy,hz,vx,vy,vz,vel;
-	IssmDouble     gravity,rho_ice,rho_water;
-	IssmDouble     epsvel=2.220446049250313e-16;
-	IssmDouble     heatcapacity,thermalconductivity,dt;
-	IssmDouble     pressure,enthalpy;
-	IssmDouble     latentheat,kappa;
-	IssmDouble     tau_parameter,diameter;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     B_conduct[3][numdof];
-	IssmDouble     B_advec[3][numdof];
-	IssmDouble     Bprime_advec[3][numdof];
-	IssmDouble     L[numdof];
-	IssmDouble     dbasis[3][6];
-	IssmDouble     D_scalar_conduct,D_scalar_advec;
-	IssmDouble     D_scalar_trans,D_scalar_stab;
-	IssmDouble     D[3][3];
-	IssmDouble     K[3][3]={0.0};
+	int        i,j,found=0;
+	IssmDouble Jdet,u,v,w,um,vm,wm;
+	IssmDouble h,hx,hy,hz,vx,vy,vz,vel;
+	IssmDouble gravity,rho_ice,rho_water;
+	IssmDouble epsvel=2.220446049250313e-16;
+	IssmDouble heatcapacity,thermalconductivity,dt;
+	IssmDouble pressure,enthalpy;
+	IssmDouble latentheat,kappa;
+	IssmDouble tau_parameter,diameter;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble B_conduct[3][numdof];
+	IssmDouble B_advec[3][numdof];
+	IssmDouble Bprime_advec[3][numdof];
+	IssmDouble L[numdof];
+	IssmDouble dbasis[3][6];
+	IssmDouble D_scalar_conduct,D_scalar_advec;
+	IssmDouble D_scalar_trans,D_scalar_stab;
+	IssmDouble D[3][3];
+	IssmDouble K[3][3]={0.0};
 	Tria*      tria=NULL;
 	GaussPenta *gauss=NULL;
@@ -3367,5 +3423,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(2,2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3476,12 +3532,12 @@
 
 	/*Intermediaries */
-	int       i,j,ig;
-	IssmDouble    mixed_layer_capacity,thermal_exchange_velocity;
-	IssmDouble    rho_ice,rho_water,heatcapacity;
-	IssmDouble    Jdet2d,dt;
-	IssmDouble    xyz_list[NUMVERTICES][3];
-	IssmDouble	 xyz_list_tria[NUMVERTICES2D][3];
-	IssmDouble    basis[NUMVERTICES];
-	IssmDouble    D_scalar;
+	int        i,j;
+	IssmDouble mixed_layer_capacity,thermal_exchange_velocity;
+	IssmDouble rho_ice,rho_water,heatcapacity;
+	IssmDouble Jdet2d,dt;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble xyz_list_tria[NUMVERTICES2D][3];
+	IssmDouble basis[NUMVERTICES];
+	IssmDouble D_scalar;
 	GaussPenta *gauss=NULL;
 
@@ -3502,11 +3558,11 @@
 	/* Start looping on the number of gauss (nodes on the bedrock) */
 	gauss=new GaussPenta(0,1,2,2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
-		
+
 		GetTriaJacobianDeterminant(&Jdet2d, &xyz_list_tria[0][0], gauss);
 		GetNodalFunctionsP1(&basis[0], gauss);
-				
+
 		D_scalar=gauss->weight*Jdet2d*rho_water*mixed_layer_capacity*thermal_exchange_velocity/(rho_ice*heatcapacity);
 		if(reCast<bool,IssmDouble>(dt)) D_scalar=dt*D_scalar;
@@ -3517,5 +3573,5 @@
 					&Ke->values[0],1);
 	}
-	
+
 	/*Clean up and return*/
 	delete gauss;
@@ -3537,10 +3593,10 @@
 /*FUNCTION Penta::CreateKMatrixThermal {{{*/
 ElementMatrix* Penta::CreateKMatrixThermal(void){
-	
+
 	/*compute all stiffness matrices for this element*/
 	ElementMatrix* Ke1=CreateKMatrixThermalVolume();
 	ElementMatrix* Ke2=CreateKMatrixThermalShelf();
 	ElementMatrix* Ke =new ElementMatrix(Ke1,Ke2);
-	
+
 	/*clean-up and return*/
 	delete Ke1;
@@ -3557,20 +3613,20 @@
 	/*Intermediaries */
 	int        stabilization;
-	int        i,j,ig,found=0;
-	IssmDouble     Jdet,u,v,w,um,vm,wm,vel;
-	IssmDouble     h,hx,hy,hz,vx,vy,vz;
-	IssmDouble     gravity,rho_ice,rho_water,kappa;
-	IssmDouble     heatcapacity,thermalconductivity,dt;
-	IssmDouble     tau_parameter,diameter;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     B_conduct[3][numdof];
-	IssmDouble     B_advec[3][numdof];
-	IssmDouble     Bprime_advec[3][numdof];
-	IssmDouble     L[numdof];
-	IssmDouble     dbasis[3][6];
-	IssmDouble     D_scalar_conduct,D_scalar_advec;
-	IssmDouble     D_scalar_trans,D_scalar_stab;
-	IssmDouble     D[3][3];
-	IssmDouble     K[3][3]={0.0};
+	int        i,j,found=0;
+	IssmDouble Jdet,u,v,w,um,vm,wm,vel;
+	IssmDouble h,hx,hy,hz,vx,vy,vz;
+	IssmDouble gravity,rho_ice,rho_water,kappa;
+	IssmDouble heatcapacity,thermalconductivity,dt;
+	IssmDouble tau_parameter,diameter;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble B_conduct[3][numdof];
+	IssmDouble B_advec[3][numdof];
+	IssmDouble Bprime_advec[3][numdof];
+	IssmDouble L[numdof];
+	IssmDouble dbasis[3][6];
+	IssmDouble D_scalar_conduct,D_scalar_advec;
+	IssmDouble D_scalar_trans,D_scalar_stab;
+	IssmDouble D[3][3];
+	IssmDouble K[3][3]={0.0};
 	Tria*      tria=NULL;
 	GaussPenta *gauss=NULL;
@@ -3599,5 +3655,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(2,2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3704,17 +3760,16 @@
 ElementMatrix* Penta::CreateKMatrixThermalShelf(void){
 
-
 	/*Constants*/
 	const int    numdof=NDOF1*NUMVERTICES;
 
 	/*Intermediaries */
-	int       i,j,ig;
-	IssmDouble    mixed_layer_capacity,thermal_exchange_velocity;
-	IssmDouble    rho_ice,rho_water,heatcapacity;
-	IssmDouble    Jdet2d,dt;
-	IssmDouble    xyz_list[NUMVERTICES][3];
-	IssmDouble	 xyz_list_tria[NUMVERTICES2D][3];
-	IssmDouble    basis[NUMVERTICES];
-	IssmDouble    D_scalar;
+	int       i,j;
+	IssmDouble mixed_layer_capacity,thermal_exchange_velocity;
+	IssmDouble rho_ice,rho_water,heatcapacity;
+	IssmDouble Jdet2d,dt;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble xyz_list_tria[NUMVERTICES2D][3];
+	IssmDouble basis[NUMVERTICES];
+	IssmDouble D_scalar;
 	GaussPenta *gauss=NULL;
 
@@ -3735,11 +3790,11 @@
 	/* Start looping on the number of gauss (nodes on the bedrock) */
 	gauss=new GaussPenta(0,1,2,2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
-		
+
 		GetTriaJacobianDeterminant(&Jdet2d, &xyz_list_tria[0][0], gauss);
 		GetNodalFunctionsP1(&basis[0], gauss);
-				
+
 		D_scalar=gauss->weight*Jdet2d*rho_water*mixed_layer_capacity*thermal_exchange_velocity/(heatcapacity*rho_ice);
 		if(reCast<bool,IssmDouble>(dt)) D_scalar=dt*D_scalar;
@@ -3750,5 +3805,5 @@
 					&Ke->values[0],1);
 	}
-	
+
 	/*Clean up and return*/
 	delete gauss;
@@ -3779,5 +3834,5 @@
 
 	/*Intermediaries*/
-	int    i,j,ig,found=0;
+	int    i,j,found=0;
 	int    friction_type,stabilization;
 	IssmDouble Jdet,phi,dt;
@@ -3822,5 +3877,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(2,3);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3875,12 +3930,12 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     Jdet2d;
-	IssmDouble     heatcapacity,h_pmp;
-	IssmDouble     mixed_layer_capacity,thermal_exchange_velocity;
-	IssmDouble     rho_ice,rho_water,pressure,dt,scalar_ocean;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     xyz_list_tria[NUMVERTICES2D][3];
-	IssmDouble     basis[NUMVERTICES];
+	int        i,j;
+	IssmDouble Jdet2d;
+	IssmDouble heatcapacity,h_pmp;
+	IssmDouble mixed_layer_capacity,thermal_exchange_velocity;
+	IssmDouble rho_ice,rho_water,pressure,dt,scalar_ocean;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble xyz_list_tria[NUMVERTICES2D][3];
+	IssmDouble basis[NUMVERTICES];
 	GaussPenta* gauss=NULL;
 
@@ -3904,5 +3959,5 @@
 	/* Start looping on the number of gauss 2d (nodes on the bedrock) */
 	gauss=new GaussPenta(0,1,2,2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3932,14 +3987,14 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
+	int        i,j;
 	int        analysis_type;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     xyz_list_tria[NUMVERTICES2D][3]={0.0};
-	IssmDouble     Jdet2d,dt;
-	IssmDouble     rho_ice,heatcapacity,geothermalflux_value;
-	IssmDouble     basalfriction,alpha2,vx,vy;
-	IssmDouble     scalar,enthalpy,enthalpyup;
-	IssmDouble     pressure,pressureup;
-	IssmDouble     basis[NUMVERTICES];
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble xyz_list_tria[NUMVERTICES2D][3]={0.0};
+	IssmDouble Jdet2d,dt;
+	IssmDouble rho_ice,heatcapacity,geothermalflux_value;
+	IssmDouble basalfriction,alpha2,vx,vy;
+	IssmDouble scalar,enthalpy,enthalpyup;
+	IssmDouble pressure,pressureup;
+	IssmDouble basis[NUMVERTICES];
 	Friction*  friction=NULL;
 	GaussPenta* gauss=NULL;
@@ -3972,5 +4027,5 @@
 	gauss=new GaussPenta(0,1,2,2);
 	gaussup=new GaussPenta(3,4,5,2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4042,5 +4097,5 @@
 
 	/*Intermediaries*/
-	int    i,j,ig,found=0;
+	int    i,j,found=0;
 	int    friction_type,stabilization;
 	IssmDouble Jdet,phi,dt;
@@ -4078,5 +4133,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(2,3);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4129,12 +4184,12 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     Jdet2d;
-	IssmDouble     mixed_layer_capacity,thermal_exchange_velocity;
-	IssmDouble     rho_ice,rho_water,pressure,dt,scalar_ocean;
-	IssmDouble     heatcapacity,t_pmp;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     xyz_list_tria[NUMVERTICES2D][3];
-	IssmDouble     basis[NUMVERTICES];
+	int        i,j;
+	IssmDouble Jdet2d;
+	IssmDouble mixed_layer_capacity,thermal_exchange_velocity;
+	IssmDouble rho_ice,rho_water,pressure,dt,scalar_ocean;
+	IssmDouble heatcapacity,t_pmp;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble xyz_list_tria[NUMVERTICES2D][3];
+	IssmDouble basis[NUMVERTICES];
 	GaussPenta* gauss=NULL;
 
@@ -4158,5 +4213,5 @@
 	/* Start looping on the number of gauss 2d (nodes on the bedrock) */
 	gauss=new GaussPenta(0,1,2,2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4186,13 +4241,13 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
+	int        i,j;
 	int        analysis_type;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     xyz_list_tria[NUMVERTICES2D][3]={0.0};
-	IssmDouble     Jdet2d,dt;
-	IssmDouble     rho_ice,heatcapacity,geothermalflux_value;
-	IssmDouble     basalfriction,alpha2,vx,vy;
-	IssmDouble     basis[NUMVERTICES];
-	IssmDouble     scalar;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble xyz_list_tria[NUMVERTICES2D][3]={0.0};
+	IssmDouble Jdet2d,dt;
+	IssmDouble rho_ice,heatcapacity,geothermalflux_value;
+	IssmDouble basalfriction,alpha2,vx,vy;
+	IssmDouble basis[NUMVERTICES];
+	IssmDouble scalar;
 	Friction*  friction=NULL;
 	GaussPenta* gauss=NULL;
@@ -4221,5 +4276,5 @@
 	/* Start looping on the number of gauss 2d (nodes on the bedrock) */
 	gauss=new GaussPenta(0,1,2,2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4410,5 +4465,5 @@
 	GetInputListOnVertices(&pressure[0],PressureEnum);
 	Input* surface_input=inputs->GetInput(SurfaceEnum); _assert_(surface_input);
-	
+
 	this->inputs->GetInputValue(&converged,ConvergedEnum);
 	if(converged){
@@ -4419,5 +4474,5 @@
 			//if(waterfraction[i]>1) _error_("Water fraction >1 found in solution vector");
 		}
-			
+
 		this->inputs->AddInput(new PentaP1Input(EnthalpyEnum,values));
 		this->inputs->AddInput(new PentaP1Input(WaterfractionEnum,waterfraction));
@@ -4463,5 +4518,5 @@
 void Penta::ControlInputGetGradient(Vector<IssmDouble>* gradient,int enum_type,int control_index){
 
-	int doflist1[NUMVERTICES];
+	int vertexpidlist[NUMVERTICES];
 	Input* input=NULL;
 
@@ -4474,5 +4529,5 @@
 		input=(Input*)material->inputs->GetInput(MaterialsRheologyZEnum);
 	}
-		
+
 	else{
 		input=inputs->GetInput(enum_type);
@@ -4481,6 +4536,6 @@
 	if (input->ObjectEnum()!=ControlInputEnum) _error_("Input " << EnumToStringx(enum_type) << " is not a ControlInput");
 
-	GradientIndexing(&doflist1[0],control_index);
-	((ControlInput*)input)->GetGradient(gradient,&doflist1[0]);
+	GradientIndexing(&vertexpidlist[0],control_index);
+	((ControlInput*)input)->GetGradient(gradient,&vertexpidlist[0]);
 
 }/*}}}*/
@@ -4507,5 +4562,5 @@
 void Penta::ControlInputSetGradient(IssmDouble* gradient,int enum_type,int control_index){
 
-	int    doflist1[NUMVERTICES];
+	int    vertexpidlist[NUMVERTICES];
 	IssmDouble grad_list[NUMVERTICES];
 	Input* grad_input=NULL;
@@ -4524,6 +4579,6 @@
 	if (input->ObjectEnum()!=ControlInputEnum) _error_("Input " << EnumToStringx(enum_type) << " is not a ControlInput");
 
-	GradientIndexing(&doflist1[0],control_index);
-	for(int i=0;i<NUMVERTICES;i++) grad_list[i]=gradient[doflist1[i]];
+	GradientIndexing(&vertexpidlist[0],control_index);
+	for(int i=0;i<NUMVERTICES;i++) grad_list[i]=gradient[vertexpidlist[i]];
 	grad_input=new PentaP1Input(GradientEnum,grad_list);
 	((ControlInput*)input)->SetGradient(grad_input);
@@ -4587,19 +4642,16 @@
 ElementMatrix* Penta::CreateKMatrixAdjointPattyn(void){
 
-	/*Constants*/
-	const int    numdof=NDOF2*NUMVERTICES;
-
 	/*Intermediaries */
-	int        i,j,ig;
+	int        i,j;
 	bool       incomplete_adjoint;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     Jdet;
-	IssmDouble     eps1dotdphii,eps1dotdphij;
-	IssmDouble     eps2dotdphii,eps2dotdphij;
-	IssmDouble     mu_prime;
-	IssmDouble     epsilon[5]; /* epsilon=[exx,eyy,exy,exz,eyz];*/
-	IssmDouble     eps1[3],eps2[3];
-	IssmDouble     phi[NUMVERTICES];
-	IssmDouble     dphi[3][NUMVERTICES];
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble Jdet;
+	IssmDouble eps1dotdphii,eps1dotdphij;
+	IssmDouble eps2dotdphii,eps2dotdphij;
+	IssmDouble mu_prime;
+	IssmDouble epsilon[5]; /* epsilon=[exx,eyy,exy,exz,eyz];*/
+	IssmDouble eps1[3],eps2[3];
+	IssmDouble phi[NUMVERTICES];
+	IssmDouble dphi[3][NUMVERTICES];
 	GaussPenta *gauss=NULL;
 
@@ -4616,5 +4668,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(5,5);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4659,16 +4711,15 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
+	int        i,j;
 	bool       incomplete_adjoint;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     Jdet;
-	IssmDouble     eps1dotdphii,eps1dotdphij;
-	IssmDouble     eps2dotdphii,eps2dotdphij;
-	IssmDouble     eps3dotdphii,eps3dotdphij;
-	IssmDouble     mu_prime;
-	IssmDouble     epsilon[5]; /* epsilon=[exx,eyy,exy,exz,eyz];*/
-	IssmDouble     eps1[3],eps2[3],eps3[3];
-	IssmDouble     phi[NUMVERTICES];
-	IssmDouble     dphi[3][NUMVERTICES];
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble Jdet;
+	IssmDouble eps1dotdphii,eps1dotdphij;
+	IssmDouble eps2dotdphii,eps2dotdphij;
+	IssmDouble eps3dotdphii,eps3dotdphij;
+	IssmDouble mu_prime;
+	IssmDouble epsilon[5]; /* epsilon=[exx,eyy,exy,exz,eyz];*/
+	IssmDouble eps1[3],eps2[3],eps3[3];
+	IssmDouble dphi[3][NUMVERTICES];
 	GaussPenta *gauss=NULL;
 
@@ -4686,5 +4737,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(5,5);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4802,5 +4853,5 @@
 	/*get gradient indices*/
 	for(int i=0;i<NUMVERTICES;i++){
-		indexing[i]=num_controls*this->nodes[i]->GetVertexDof() + control_index;
+		indexing[i]=num_controls*this->nodes[i]->GetVertexPid() + control_index;
 	}
 
